precision mediump float;
uniform sampler2D y_tex;
uniform sampler2D u_tex;
uniform sampler2D v_tex;
varying vec2 interp_tc;
uniform float lum_threshold_1;
uniform float lum_threshold_2;
uniform float lum_threshold_3;
uniform float lum_threshold_4;
uniform float width;
uniform float modv;
uniform float minus;
uniform float color;


void main() {
     vec2 uv = interp_tc;
     vec3 tc = vec3(1.0, 1.0, 1.0);
     float y = texture2D(y_tex, uv).r;
     float u = texture2D(u_tex, uv).r - 0.5;
     float v = texture2D(v_tex, uv).r - 0.5;
     vec3 uv_color = vec3(y + 1.403 * v, y - 0.344 * u - 0.714 * v, y + 1.77 * u);
     float lum = length(uv_color.rgb);

     if (lum < lum_threshold_1) {
          if (mod(gl_FragCoord.x + gl_FragCoord.y, modv) <= width) {
               tc = vec3(color, color, color);
          }
     }

     if (lum < lum_threshold_2) {
          if (mod(gl_FragCoord.x - gl_FragCoord.y, modv) <= width) {
               tc = vec3(color, color, color);
          }
     }

     if (lum < lum_threshold_3) {
          if (mod(gl_FragCoord.x + gl_FragCoord.y - minus, modv) <= width) {
               tc = vec3(color, color, color);
          }
     }

     if (lum < lum_threshold_4) {
          if (mod(gl_FragCoord.x - gl_FragCoord.y - minus, modv) <= width) {
               tc = vec3(color, color, color);
          }
     }

     gl_FragColor = vec4(tc, 1.0);
}