precision mediump float;
varying highp vec2 interp_tc;
uniform sampler2D rgb_tex;
uniform float saturation;
const vec3 luminanceWeighting = vec3(0.2125, 0.7154, 0.0721);
vec3 ContrastSaturationBrightness(vec3 color, float brt, float sat, float con)
{
    const float AvgLumR = 0.5;
    const float AvgLumG = 0.5;
    const float AvgLumB = 0.5;
    vec3 AvgLumin = vec3(AvgLumR, AvgLumG, AvgLumB);
    vec3 brtColor = color * brt;
    vec3 intensity = vec3(dot(brtColor, luminanceWeighting));
    vec3 satColor = mix(intensity, brtColor, sat);
    vec3 conColor = mix(AvgLumin, satColor, con);
    return conColor;
}
void main()
{
    vec4 textureColor = texture2D(rgb_tex, interp_tc);
    vec3 color = ContrastSaturationBrightness(textureColor.rgb, 1.0, saturation, 1.0);
    gl_FragColor = vec4(color, 1.0);
}